House Robber

Leetcode-Algorithm-DP-198

题目:
You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.
Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.
(假定你是一个专业的盗贼,你打算盗窃一条街上所有的房屋,每套房里面都有一定的现金。然而主要的问题是如果同一晚里面相邻的两间房子同时被盗窃的话,就会引发警报。给定一个非负整数数组表示每间屋子里所有的现金的数量,那么在不引发警报的前提下,如何能获得最大数额的现金呢?)

例子:
给定:nums = [2, 1, 1, 2].
输出:4

给定:nums = [2, 1].
输出:2

给定:nums = [].
输出:0


题解:
方法:(动态规划DP)
抽象地看,我们不知道什么样的序列能够使得盗贼在偷到最后一间房子的时候能获得做多的现金,但我们可以假定在偷到最后一间房子之前已经获得了之前所有房子能够得到的最大现金。那么对于当前这个房子来说就有两种可能的情况:①需要拿这个房子的现金,这时为了不引发警报,前一间房子是不能偷的;②不需要拿当前这个房子的现金,那么现在手头的现金量就是之前所有的房子能拿到的最大现金。这样,我们就能使用动态规划策略来解决这个问题了。状态转移函数是f(i) = max{f(i-2)+wi, f(i-1)}。

class Solution {
public:
    int rob(vector<int>& nums) {
        if (nums.empty()) return 0;
        for (int i = 1; i < nums.size(); ++i)
            if (i == 1)
                nums[i] = (nums[i-1] > nums[i] ? nums[i-1] : nums[i]);
            else 
                nums[i] = (nums[i]+nums[i-2] > nums[i-1] ? nums[i]+nums[i-2] : nums[i-1]);

        return nums[nums.size()-1];
    }
};

分析:
由于只需迭代一次数组,因此总的时间复杂度为 O(n)

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值